# Amazon US, UK, CA music scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    cSymbol = "$"

    aw.setCurrencySymbol(cSymbol)


    tag = "<div class=\"fastTrack\">This item is currently not available.</div>"

    i = string.find(source, tag)

    if i != -1:
        # Amazon returning not found, try again
        source = searchForPlus(source, "\"searchKeywords\":")
        source = searchForPlus(source, "\"")
        i = string.find(source, "\"")
        isbn = stripText(source[0:i])
        url = "http://www.amazon.com/s/ref=nb_ss?url=search-alias%3Dpopular&field-keywords=" + isbn
        print "New url=",url
        http = HTTPConnection()
        
        try:
            http.setGenericUserAgent()
        except:
            print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url)
        
        try:
            t = open(rw.getLogsDir() + "trace1a.html", "w")
            t.write(source)
            t.close()
        except:
            print "Unable to create trace.html"


    i = string.find(source, ">Please verify that this is the")

    if i != -1:
        source = searchForPlus(source, ">Please verify that this is the")
        source = searchForPlus(source, "class=\"headerblocktitle\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace.html", "w")
        t2.write(source)
        t2.close()


    tag = "class=\"listView\""

    if string.find(source, tag) == -1:
        tag = "class=\"resultCount\""

    if string.find(source, tag) == -1:
        tag = "class=resultCount"

    if string.find(source, tag) == -1:
        tag = "id=\"result_0\""

    i = string.find(source, tag)

    if i != -1:
        # Amazon search results page, follow link
        source = searchForPlus(source, tag)

        i = string.find(source, "title=\"Audio CD\"")

        if i != -1:
            source = searchForPlus(source, "title=\"Audio CD\"")
        else:
            i = string.find(source, "data-attribute=\"Audio CD\"")

            if i != -1:
                source = stripText(source[i-500:])

        source = searchForPlus(source, " href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        
        #
        # Here is the problem. If we pretend to be Mozilla, Amazon uses advanced HTML, i.e. product
        # description is an object and not included in the HTML. So to get description we must be 
        # Readerware so that Amazon generates a basic HTML page.
        #try:
        #    http.setGenericUserAgent()
        #except:
        #    print "Unable to set UA"

        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Find Image
    imageFound = 0
    image = ""
    i = string.find(source, "registerImage(\"original_image\"")

    if i != -1:
        images = searchForPlus(source, "registerImage(\"original_image\"")
        images = searchForPlus(images, "\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                aw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                aw.setImage1(image)
            else:
                aw.setImage1(image)

            imageFound = 1


    # Find Image
    tag = "id=\"main_image_0\""

    i = string.find(source, tag)

    if i == -1:
        tag = "id=\"main-image-nonjs\""
        i = string.find(source, tag)

    #if i == -1:
    #    tag = "<li class=\"image\n"
    #    i = string.find(source, tag)

    if i != -1:
        images = searchForPlus(source, tag)
        images = searchForPlus(images, "src=\"")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "no-image")

        if i == -1:
            i = string.find(image, ",")

            if i != -1:
                j = string.rfind(image[i:], ",")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "_AA")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                aw.setLargeImage1(large)
                image = stripText(image[0:i] + "_SL280" + image[j:])
                aw.setImage1(image)

            i = string.find(image, "_SY300_")

            if i != -1:
                large = string.replace(image, "_SY300_", "_SY500_")
                aw.setLargeImage1(large)
                aw.setImage1(image)
            else:
                aw.setImage1(image)

            imageFound = 1

    if aw.getLargeImage1() == None:
        i = string.find(source, "class=\"quorus-product-photo\"")

        if i != -1:
            images = stripText(source[i-200:])
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])

            i = string.find(image, "_SL")

            if i != -1:
                j = string.find(image, "_.")
                large = stripText(image[0:i] + image[j:])
                aw.setLargeImage1(large)

                imageFound = 1


    if imageFound == 0:                    
        tag = "'colorImages'"

        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            i = string.find(images, "\n")
            images = stripText(images[0:i])
            i = string.find(images, "\"main\"")

            if i != -1:
                images = searchForPlus(images, "\"large\"")
                i = string.find(images, "http")
                image = stripText(images[i:])
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                aw.setLargeImage1(image)

                images = searchForPlus(images, "\"main\"")
                i = string.find(images, "http")
                image = stripText(images[i:])
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                image = string.replace(image, "PJautoripBadge,BottomRight,4,-40_", "")
                aw.setImage1(image)

                imageFound = 1


    if imageFound == 0:                    
        tag = "data-feature-name=\"coverArt\""

        i = string.find(source, tag)

        if i != -1:
            images = searchForPlus(source, tag)
            images = searchForPlus(images, "src=\"")
            i = string.find(images, "\"")
            image = stripText(images[0:i])
            image = string.replace(image, "PJStripe-Robin,TopLeft,0,0", "")
            aw.setImage1(image)
            image = string.replace(image, "_SS280_", "")
            aw.setLargeImage1(image)

            imageFound = 1


    # Find List price
    i = string.find(source, "class=\"listprice\">")

    if i != -1:
        value = searchForPlus(source, "class=\"listprice\">")
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "<")
        aw.setListPrice(value[0:i])


    # Find value
    tag = "class=\"priceLarge\">"

    if string.find(source, tag) == -1:
        tag = "class=\"a-size-medium a-color-price"

    i = string.find(source, tag)

    if i != -1:
        value = searchForPlus(source, tag)
        value = searchForPlus(value, cSymbol)
        i = string.find(value, "<")
        aw.setItemValue(value[0:i])
        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find new price/count
    i = string.find(source, "olp-new olp-link")

    if i != -1:
        new = searchForPlus(source, "olp-new olp-link")
        new = searchForPlus(new, "condition=new")
        new = stripText(searchForPlus(new, ">"))
        i = string.find(new, " ")
        aw.setNewCount(new[0:i])

        new = searchForPlus(new, cSymbol)
        i = string.find(new, "<")
        aw.setNewPrice(new[0:i])


    # Find used price/count
    i = string.find(source, "olp-used olp-link")

    if i != -1:
        used = searchForPlus(source, "olp-used olp-link")
        used = searchForPlus(used, "condition=used")
        used = stripText(searchForPlus(used, ">"))
        i = string.find(used, " ")
        aw.setUsedCount(used[0:i])

        used = searchForPlus(used, cSymbol)
        i = string.find(used, "<")
        aw.setUsedPrice(used[0:i])


    # Find collectible price/count
    i = string.find(source, "olp-collectible olp-link")

    if i != -1:
        col = searchForPlus(source, "olp-collectible olp-link")
        col = searchForPlus(col, "condition=collectible")
        col = stripText(searchForPlus(col, ">"))
        i = string.find(col, " ")
        aw.setCollectibleCount(col[0:i])

        col = searchForPlus(col, cSymbol)
        i = string.find(col, "<")
        aw.setCollectiblePrice(col[0:i])


    # Find Keywords
    i = string.find(source, "name=\"field+keywords\"")

    if i != -1:
        extracted = ""
        keywords = searchFor(source, "name=\"field+keywords\"")

        while (searchFor(keywords, "name=\"field+keywords\"") != None):
            keywords = searchForPlus(keywords, "name=\"field+keywords\"")
            keywords = searchForPlus(keywords, "value=\"")
            i = string.find(keywords, "\"")
            keyword = stripText(keywords[0:i])

            if extracted == "":
                extracted = keyword
            else:
                extracted = extracted + ", " + keyword

        aw.setKeywords(extracted)


    # Find Format
    i = string.find(source, "&nbsp;Format:&nbsp;</span>MP3 Music</div>")

    if i != -1:
        aw.setFormat("MP3")


    # Find Title
    tag = "\"btAsinTitle\""

    if string.find(source, tag) == -1:
        tag = "id=\"productTitle\""

    if string.find(source, tag) == -1:
        tag = "id=\"mediaProductTitle\""

    if string.find(source, tag) == -1:
        # MP3 listing tag
        tag = "id=\"title_row\""
        aw.setFormat("MP3")

    if string.find(source, tag) == -1:
        # MP3 listing tag
        tag = "id=\"title_feature_div\""
        aw.setFormat("MP3")

    source = searchForPlus(source, tag)
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")
        source = stripText(source)

    if source.startswith("<h1") == 1:
        source = searchForPlus(source, ">")
        source = stripText(source)

    i = string.find(source, "<")
    title = stripText(source[0:i])

    i = string.rfind(title, "[")

    if i != -1:
        title = stripText(title[0:i])

    aw.setTitle(title)


    # Find Artist
    if string.find(source, "id=\"ProductInfoArtistLink\"") != -1:
        # Amazon US MP3
        artists = searchFor(source, "id=\"ProductInfoArtistLink\"")
        artists = searchForPlus(artists, "href=\"")
        artists = searchForPlus(artists, "\">")
        i = string.find(artists, "<")
        artist = stripText(artists[0:i])
        aw.setArtist(artist)
    else:
        artistList = []

        tag = "ref=ntt_mus_"

        if string.find(source, tag) == -1:
            tag = "ref=dm_dp_adp"

        if string.find(source, tag) == -1:
            # Amazon UK
            tag = "ref=ntt_art_dp"

        if string.find(source, tag) == -1:
            # MP3
            tag = "id='artistBlurb'"

        if string.find(source, tag) == -1:
            # No artist identifier, look for next link.
            tag = "href=\"/"

        if string.find(source, tag) != -1:
            artists = searchFor(source, tag)
            i = string.find(artists, "\n")
            artists = stripText(artists[0:i])

            while (searchFor(artists, tag) != None):
                artists = searchForPlus(artists, tag)
                artists = searchForPlus(artists, "\">")
                i = string.find(artists, "<")
                artist = stripText(artists[0:i])
                artists = searchForPlus(artists, "</a>")
                artists = stripText(artists)

                if artists.startswith("<span class=\"byLinePipe\">") == 1:
                    artists = searchForPlus(artists, "<span class=\"byLinePipe\">")

                if artists.startswith("(") == 1:
                    i = string.find(artists, ")")
                    role = stripText(artists[0:i+1])

                    if role == "(Composer)":
                        if aw.getComposer() == "":
                            aw.setComposer(artist)
                            artist = ""
                    elif role == "(Conductor)":
                        if aw.getConductor() == "":
                            aw.setConductor(artist)
                            artist = ""
                    elif role == "(Orchestra)":
                        if aw.getOrchestra() == "":
                            aw.setOrchestra(artist)
                            artist = ""
                    elif role == "(Soloist)":
                        if aw.getSoloist() == "":
                            aw.setSoloist(soloist)
                            artist = ""

                if artist != "":
                    artistList.append(artist)

            aw.setArtists(artistList)


    # Find Tracks
    i = string.find(source, ">Listen to Samples and Buy MP3s<")
    gotTracks = 0

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        disks = searchForPlus(source, ">Listen to Samples and Buy MP3s<")
        disks = searchForPlus(disks, "id='albumTrackList'")
        i = string.find(disks, "id=\"productDetails\"")
        disks = stripText(disks[0:i])

        disks = "id=\"dmusic_tracklist_player_disc_1" + disks

        diskCount = 0

        while (searchFor(disks, "id=\"dmusic_tracklist_player_disc_") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "id=\"dmusic_tracklist_player_disc_")

            i = string.find(disks, "id=\"dmusic_tracklist_player_disc_")

            if i != -1:
                tracks = stripText(disks[0:i])
            else:
                tracks = disks

            trackCount = 0

            while (searchFor(tracks, "class=\"titleCol\"") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, "class=\"titleCol\"")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.rfind(title, "(")

                if i >= 1:
                    title = stripText(title[0:i])

                artist = ""
                i = string.find(tracks, "class=\"titleCol\"")

                if i != -1 and i < 100:
                    tracks = searchForPlus(tracks, "class=\"titleCol\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                tracks = searchForPlus(tracks, "class=\"runtimeCol\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])

                bonus = ""

                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time, bonus=bonus)


    tag = ">Track Listings<"
    i = string.find(source, tag)

    if i == -1:
        tag = "Track Listings"
        i = string.find(source, tag)

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        disks = searchForPlus(source, tag)
        i = string.find(disks, "<hr no")
        disks = stripText(disks[0:i])
        i = string.find(disks, "ref=dp_tracks_all_1")

        if i == -1:
            i = string.find(disks, "/ref=dp_tracks_all_full")

        if i == -1:
            i = string.find(disks, " tracks on this disc<")

        if i == -1:
            i = string.find(disks, ">See all items<")

        if i != -1:
            disks = stripText(disks[i-175:])
            disks = searchForPlus(disks, "<a href=\"")
            i = string.find(disks, "\">")
            url = "" + stripText(disks[0:i])
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            disks = http.getContents(url)
            disks = searchForPlus(disks, tag)
            i = string.find(disks, "<hr no")
            disks = stripText(disks[0:i])
            

        if string.find(disks, "Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        diskCount = 0

        while (searchFor(disks, "Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "Disc: ")
            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])

            i = string.find(tracks, "Disc: ")

            if i != -1:
                tracks = stripText(tracks[0:i])

            i = string.find(tracks, "<div id=\"")

            if i != -1:
                tracks = stripText(tracks[0:i])

            trackCount = 0
            title = ""
            artist = ""
            time = ""
            bonus = ""

            while (searchFor(tracks, ". ") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, ". ")

                if (tracks[0:1] == "<"):
                    i = string.find(tracks, "<A HREF=")

                    if (i == 0):
                      i = string.find(tracks, ">")
                      tracks = stripText(tracks[i+1:])

                i = string.find(tracks, "<")

                if i != -1:
                    title = stripText(tracks[0:i])
                    j = string.find(title, ">")

                    if (j != -1):
                        title = stripText(title[j+1:])

                    j = string.find(title, " - ")

                    if (j != -1):
                        artist = stripText(title[j+3:])
                        title = stripText(title[0:j])

                tracks = tracks[i+1:]
                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time, bonus=bonus)


    # Find Tracks
    i = string.find(source, "class=\"headerTitle\">MP3 Songs")

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        # Intentionally searching for another key so that we get the >Disc tag
        source = searchForPlus(source, "id='albumTrackList'")
        disks = stripText(source)

        if string.find(disks, ">Disc ") == -1:
            disks = ">Disc 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc ")
            disks = searchForPlus(disks, "class=\"columnHeader\"")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])

            trackCount = 0

            while (searchFor(tracks, "class=\"titleCol\"") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, "class=\"titleCol\"")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.rfind(title, "(")

                if i >= 1:
                    title = stripText(title[0:i])

                artist = ""
                i = string.find(tracks, "class=\"titleCol\"")

                if i != -1 and i < 100:
                    tracks = searchForPlus(tracks, "class=\"titleCol\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                tracks = searchForPlus(tracks, "class=\"runtimeCol\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])

                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time)


    # Find Tracks - Amazon US MP3
    i = string.find(source, "id=\"dmusic_tracklist_player\"")

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        disks = searchForPlus(source, "id=\"dmusic_tracklist_player\"")
        i = string.find(disks, "id=\"purchase-sims-feature\"")
        disks = stripText(disks[0:i])

        disks = "id=\"dmusic_tracklist_player_disc_1" + disks

        diskCount = 0

        while (searchFor(disks, "id=\"dmusic_tracklist_player_disc_") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, "id=\"dmusic_tracklist_player_disc_")

            i = string.find(disks, "id=\"dmusic_tracklist_player_disc_")

            if i != -1:
                tracks = stripText(disks[0:i])
            else:
                tracks = disks

            trackCount = 0

            while (searchFor(tracks, "\"dmusic_tracklist_track_title") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, "\"dmusic_tracklist_track_title")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, "\">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                if title == "Terms of Use":
                    continue

                i = string.rfind(title, "(")

                if i >= 1:
                    title = stripText(title[0:i])

                artist = ""
                i = string.find(tracks, "dmusic_tracklist_artist_name_")

                if i != -1:
                    tracks = searchForPlus(tracks, "dmusic_tracklist_artist_name_")
                    tracks = searchForPlus(tracks, " title=\"")
                    i = string.find(tracks, "\"")
                    artist = stripText(tracks[0:i])

                i = string.find(tracks, " ArtistLink\"")

                if i != -1:
                    tracks = searchForPlus(tracks, " ArtistLink\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, "\">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                time = ""
                i = string.find(tracks, "id=\"dmusic_tracklist_duration")

                if i != -1:
                    tracks = searchForPlus(tracks, "id=\"dmusic_tracklist_duration")
                    tracks = searchForPlus(tracks, "<span ")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    time = stripText(tracks[0:i])

                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time)


    # Find Tracks (Amazon UK MP3)
    i = string.find(source, "class=\"mp3Header\">MP3 Songs")

    if gotTracks == 0 and i != -1:
        gotTracks = 1
        source = searchForPlus(source, "class=\"mp3Header\">MP3 Songs")
        disks = stripText(source)

        if string.find(disks, ">Disc ") == -1:
            disks = ">Disc 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc ")

            i = string.find(disks, "class=\"mp3Tracks\"")

            if i != -1:
                disks = searchForPlus(disks, "class=\"mp3Tracks\"")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])

            trackCount = 0

            while (searchFor(tracks, "<td class=\"songTitle\"") != None):
                trackCount = trackCount + 1
                tracks = searchForPlus(tracks, "<td class=\"songTitle\"")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.rfind(title, "(")

                if i >= 1:
                    title = stripText(title[0:i])

                artist = ""
                i = string.find(tracks, "class=\"artist\"")

                if i != -1 and i < 100:
                    tracks = searchForPlus(tracks, "class=\"artist\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                tracks = searchForPlus(tracks, "class=\"runtimeCol\"")
                tracks = searchForPlus(tracks, ">")
                tracks = stripText(tracks)

                if tracks.startswith("<meta") == 1:
                    tracks = searchForPlus(tracks, ">")

                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])

                aw.setTrack(diskCount, trackCount, title, artist=artist, time=time)


    # Find Format
    tag = ">Product Details<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Product details<"
        i = string.find(source, tag)

    if i != -1:
        attr = searchForPlus(source, tag)
        attr = searchForPlus(attr, "<li>")
        i = string.find(attr, "</li>")
        attr = stripText(attr[0:i])

        i = string.find(attr, "Audio CD")

        if i != -1:
            aw.setFormat("CD")

        i = string.find(attr, "Audio Cassette")

        if i != -1:
            aw.setFormat("Cassette")

        i = string.find(attr, "Vinyl")

        if i != -1:
            aw.setFormat("LP")

        # Find Date
        i = string.find(attr, "(")

        if i != -1:
            attr = searchForPlus(attr, "(")
            i = string.find(attr, ")")
            aw.setReleaseDate(attr[0:i])


    # Find Copyright date
    i = string.find(source, ">Original Release Date:<")

    if i != -1:
        date = searchForPlus(source, ">Original Release Date:<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        aw.setCopyrightDate(date[0:i])


    # Find Release date
    i = string.find(source, ">Release Date:<")

    if i != -1:
        date = searchForPlus(source, ">Release Date:<")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        aw.setReleaseDate(date[0:i])


    # Find Category
    tag = ">Genres:<"

    if string.find(source, tag) == -1:
        tag = "Similar Items by Category<"

    if string.find(source, tag) == -1:
        # Amazon UK
        tag = ">Look for similar items by category<"

    if string.find(source, tag) != -1:
        cats = searchForPlus(source, tag)
        i = string.find(cats, "</ul>")
        cats = stripText(cats[0:i])

        i = string.find(cats, "</li>")

        if i != -1:
            cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=\"") != None):
            cats = searchForPlus(cats, "href=\"")
            cats = searchForPlus(cats, "\">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Music":
                continue

            if cat == "CDs & Vinyl":
                continue

            if ccount == 1:
                aw.setCategory1(cat)
            elif ccount == 2:
                aw.setCategory2(cat)
            else:
                aw.setCategory3(cat)
                break

            ccount = ccount + 1


    # Find Recording Type
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        aw.setRecording(format[0:i])


    # Find Label
    i = string.find(source, ">Label:<")

    if i != -1:
        label = searchForPlus(source, ">Label:<")
        label = searchForPlus(label, ">")
        i = string.find(label, "<")
        aw.setLabel(label[0:i])


    # Find ASIN
    i = string.find(source, ">ASIN:<")

    if i != -1:
        asin = searchForPlus(source, ">ASIN:<")
        asin = searchForPlus(asin, ">")
        i = string.find(asin, "<")
        aw.setASIN(asin[0:i])


    # Find User Rating
    i = string.find(source, ">Average Customer Review:<")

    if i != -1:
        rating = searchForPlus(source, ">Average Customer Review:<")
        rating = searchForPlus(rating, "class=\"swSprite s_star_")

        if rating != None:
            rating = searchForPlus(rating, "<span>")
            i = string.find(rating, " ")
            aw.setMyRating(rating[0:i])


    # Find Sales Rank
    tag = "Sales Rank:<"

    if string.find(source, tag) == -1:
        tag = " Bestsellers Rank:<"

    if string.find(source, tag) == -1:
        tag = " Best Sellers Rank:"

    i = string.find(source, tag)

    if i != -1:
        rank = searchForPlus(source, tag)
        rank = searchForPlus(rank, ">")
        i = string.find(rank, "<")
        rank = stripText(rank[0:i])

        i = string.find(rank, " ")

        if i != -1:
            rank = stripText(rank[0:i])

        if rank.startswith("#") == 1:
            rank = stripText(rank[1:])

        aw.setSalesRank(rank)


    # Find Composer
    i = string.find(source, ">Composer:")

    if i != -1:
        composer = searchForPlus(source, ">Composer:")
        composer = searchForPlus(composer, "\">")
        i = string.find(composer, "<")
        aw.setComposer(composer[0:i])


    # Find Performer
    i = string.find(source, ">Performer:<")

    if i != -1:
        artist = searchForPlus(source, ">Performer:<")
        artist = searchForPlus(artist, "\">")
        i = string.find(artist, "<")
        aw.setSoloist(artist[0:i])


    # Find Conductor
    i = string.find(source, ">Conductor:<")

    if i != -1:
        conductor = searchForPlus(source, ">Conductor:<")
        conductor = searchForPlus(conductor, "\">")
        i = string.find(conductor, "<")
        aw.setConductor(conductor[0:i])


    # Find Orchestra
    i = string.find(source, ">Orchestra:<")

    if i != -1:
        orchestra = searchForPlus(source, ">Orchestra:<")
        orchestra = searchForPlus(orchestra, "\">")
        i = string.find(orchestra, "<")
        aw.setOrchestra(orchestra[0:i])


    # Find Comments
    tag = "Editorial Reviews"
    comments = "Editorial Reviews<BR>"

    if string.find(source, tag) == -1:
        # Amazon UK comments
        tag = "Product description"
        comments = ""

    if string.find(source, tag) != -1:
        reviews = searchForPlus(source, tag)
        reviews = searchForPlus(reviews, ">")

        i = string.find(reviews, "<style")

        if i != -1:
            reviews = stripText(reviews[0:i])

        while (searchFor(reviews, "id=\"productDescription\"") != None):
            reviews = searchForPlus(reviews, "id=\"productDescription\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])

            comments = appendComment(comments, comment)

        while (searchFor(reviews, "class=\"productDescriptionWrapper\"") != None):
            reviews = searchForPlus(reviews, "class=\"productDescriptionWrapper\"")
            reviews = searchForPlus(reviews, ">")
            i = string.find(reviews, "</div>")
            comment = stripText(reviews[0:i])

            comments = appendComment(comments, comment)


        aw.setProductInfo(comments)





try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
