# Amazon UK music scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("")

    i = string.find(source, "The item you indicated is ineligible for Amazon Marketplace selling.")

    if i != -1:
        return


    i = string.find(source, "sai-identify")

    if i != -1:
        source = searchForPlus(source, "sai-identify")
        i = string.find(source, "/ASIN/")
        source = source[i-50:]
        source = searchForPlus(source, "<a href=")
        i = string.find(source, ">")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    i = string.find(source, "id=\"atfResults\"")

    if i != -1:
        source = searchForPlus(source, "id=\"atfResults\"")
        source = searchForPlus(source, " href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(aw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()


    # Main extraction
    titleartist = searchForPlus(source, "<title>")
    i = string.find(titleartist, "</title>")
    titleartist = stripText(titleartist[0:i])
    i = string.find(titleartist, ":")

    if i != -1:
        titleartist = stripText(titleartist[i+1:])
        i = string.find(titleartist, ":")

        if i != -1:
            titleartist = stripText(titleartist[0:i])


    # Find Image (first try)
    image = ""
    i = string.find(source, "var imageSrc")

    if i != -1:
        image = searchForPlus(source, "var imageSrc")
        image = searchForPlus(image, "\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "no-image")

        if i != -1:
            image = ""

        image = string.replace(image, "PJautoripBadge,BottomRight", "")
        aw.setImage1(image)

        image = searchForPlus(source, "var imageSrc")
        i = string.find(image, "[{\"large\":")

        if i != -1 and i < 250:
            image = searchForPlus(image, "[{\"large\":")
            image = searchForPlus(image, "\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "no-image")

            if i != -1:
                image = ""

            aw.setLargeImage1(image)




    # Find Title
    source = searchForPlus(source, "\"btAsinTitle\"")
    source = searchForPlus(source, ">")
    source = stripText(source)

    if source.startswith("<span") == 1:
        source = searchForPlus(source, ">")

    i = string.find(source, "<")
    title = stripText(source[0:i])
    aw.setTitle(title)


    # Find Artist
    tag = "field-artist"
    i = string.find(source, tag)

    if i == -1:
        tag = "field-keywords="
        i = string.find(source, tag)

    if i != -1:
        artist = searchForPlus(source, tag)
        artist = searchForPlus(artist, ">")
        i = string.find(artist, "<")
        artist = stripText(artist[0:i])
        aw.setArtist(artist)

    if title != "" and artist == "":
        print "Getting artist from <title>: ",titleartist
        aw.setArtist(titleartist)


    # Find Image
    if image == "":
        tag = "images.amazon.com"
        i = string.find(source, tag)

        if i == -1 or i > 3000:
            tag = "images-amazon.com/"
            i = string.find(source, tag)

        if i != -1 and i < 3000:
            image = source[i-50:]
            image = searchForPlus(image, " src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])
            image = string.replace(image, ".LZZZ", ".MZZZ")
            image = string.replace(image, ".TZZZ", ".MZZZ")

            i = string.find(image, "_PE")

            if i != -1:
                j = string.find(image[i+1:], "_")
                image = stripText(image[0:i] + image[i+j+1:])

            i = string.find(image, "ZZZ")

            if i == -1:
                image = ""

        aw.setImage1(image)


    # find listprice
    i = string.find(source,"Preisempfehlung&#42;:&#160;<")

    if i != -1:
    	source = searchForPlus(source,"Preisempfehlung&#42;:&#160;<")
    	source = searchForPlus(source,">")
    	i = string.find(source,"<")
    	listprice = stripText(source[0:i])
        aw.setListPrice(listprice)

    # Find Price
    i = string.find(source, "id=\"actualPriceValue\"")

    if (i != -1):
        source = searchForPlus(source, "id=\"actualPriceValue\"")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        value = stripText(source[0:i])
        value = string.replace(value, "EUR", "")
        aw.setItemValue(value)
        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Categories
    category = ""
    i = string.find(source, ">Buscar productos similares por categora<")

    if i != -1:
        cats = searchForPlus(source, ">Buscar productos similares por categora<")
        cats = searchForPlus(cats, "<li>")
        i = string.find(cats, "</li>")
        cats = stripText(cats[0:i])

        ccount = 1

        while (searchFor(cats, "href=") != None):
            cats = searchForPlus(cats, "href=")
            cats = searchForPlus(cats, ">")
            i = string.find(cats, "<")
            cat = stripText(cats[0:i])

            if cat == "Msica":
                continue

            if ccount == 1:
                aw.setCategory1(cat)
            elif ccount == 2:
                aw.setCategory2(cat)
            else:
                aw.setCategory3(cat)
                break

            ccount = ccount + 1


    # Find Format
    i = searchForPlus(source, "<a name=\"productDetails\"")

    if i != -1:
        attributes = searchForPlus(source, "<a name=\"productDetails\"")
        # first item of the description data should be the format
        attributes = searchForPlus(attributes, "<li><b>")
        i = string.find(attributes, "</ul>")
        attributes = attributes[0:i]
        i = string.find(attributes, ":</b>")
        format = stripText(attributes[0:i])
        i = string.find(format, "(")

        if i != -1:
            format = stripText(format[0:i])

        aw.setFormat(format)
    

        # Find Release date
        attributes = searchForPlus(attributes, "</b>")
        i = string.find(attributes, "(")

        if i != -1:
            date = searchForPlus(attributes, "(")  
            i = string.find(date, ")")
            aw.setReleaseDate(stripText(date[0:i]))


    # Find Composer
    i = string.find(source, ">Composer:<")

    if i != -1:
        composer = searchForPlus(source, ">Composer:<")
        composer = searchForPlus(composer, "\">")
        i = string.find(composer, "<")
        composer = stripText(composer[0:i])
        aw.setComposer(composer)


    # Find Conductor
    i = string.find(source, ">Conductor:<")

    if i != -1:
        conductor = searchForPlus(source, ">Conductor:<")
        conductor = searchForPlus(conductor, "\">")
        i = string.find(conductor, "<")
        conductor = stripText(conductor[0:i])
        aw.setConductor(conductor)


    # Find Label
    i = string.find(source, ">Sello:<")

    if i != -1:
        label = searchForPlus(source, ">Sello:<")
        label = searchForPlus(label, ">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Date (2nd attempt)
    i = string.find(source, ">Released:")

    if i != -1:
        source = searchForPlus(source, ">Released:")
        i = string.find(source, "<")
        date = stripText(source[0:i])
        aw.setReleaseDate(date)


    # Find Tracks
    i = string.find(source, ">Titelverzeichnis <")

    if i != -1:
        disks = searchForPlus(source, ">Titelverzeichnis <")
        i = string.find(disks, "</div>")
        disks = stripText(disks[0:i])
        i = string.find(disks, " Titel anzeigen.</a>")

        if i != -1:
            disks = stripText(disks[i-200:])
            disks = searchForPlus(disks, "<a href=\"")
            i = string.find(disks, "\">")
            url = "" + stripText(disks[0:i])
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            disks = http.getContents(url)
            disks = searchForPlus(disks, ">Titelverzeichnis <")
            i = string.find(disks, "<hr no")
            disks = stripText(disks[0:i])
            t2 = open(aw.getLogsDir() + "trace2.html", "w")
            t2.write(disks)
            t2.close()

        if string.find(disks, ">Disk: ") == -1:
            disks = ">Disk: 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disk: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disk: ")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])

            i = string.find(disks, "</table>")

            if i != -1:
                i = string.find(disks, "</table>")
                tracks = stripText(disks[0:i])
            else:
                tracks = disks

            trackCount = 0

            while (searchFor(tracks, ". ") != None):
                tracks = searchForPlus(tracks, ". ")

                if (tracks[0:1] == "<"):
                    i = string.find(tracks, "<A HREF=")

                    if i == 0:
                      i = string.find(tracks, ">")
                      tracks = stripText(tracks[i+1:])

                i = string.find(tracks, "<")

                if i != -1:
                    track = stripText(tracks[0:i])
                    i = string.find(track, ">")

                    if i != -1:
                        track = stripText(track[i+1:])

                    i = string.find(track, " - ")
                    artist = ""

                    if i != -1:
                        artist = stripText(track[i+3:])
                        track = stripText(track[0:i])

                aw.setTrack(diskCount, trackCount, track, artist=artist)
                trackCount = trackCount + 1


    tag = ">Hrbeispiele<"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Titelverzeichnis"
        i = string.find(source, tag)

    if i != -1:
        source = searchForPlus(source, tag)
        i = string.find(source, "<hr ")
        disks = stripText(source[0:i])
        i = string.find(disks, " Titel anzeigen.</a>")

        if i != -1:
            disks = stripText(disks[i-200:])
            disks = searchForPlus(disks, "<a href=\"")
            i = string.find(disks, "\">")
            url = "" + stripText(disks[0:i])
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            disks = http.getContents(url)
            disks = searchForPlus(disks, tag)
            i = string.find(disks, "<hr no")
            disks = stripText(disks[0:i])
            t2 = open(aw.getLogsDir() + "trace2.html", "w")
            t2.write(disks)
            t2.close()

        if string.find(disks, ">Disk: ") == -1:
            disks = ">Disk: 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disk: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disk: ")
            i = string.find(disks, "<")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])
            i = string.find(tracks, ">Disk: ")

            if i != -1:
                tracks = stripText(tracks[0:i])

            trackCount = 1

            while (searchFor(tracks, ". ") != None):
                tracks = searchForPlus(tracks, ". ")

                if (tracks[0:1] == "<"):
                    i = string.find(tracks, "<A HREF=")

                    if (i == 0):
                      i = string.find(tracks, ">")
                      tracks = stripText(tracks[i+1:])

                i = string.find(tracks, "<")

                if (i != -1):
                    track = stripText(tracks[0:i])
                    i = string.find(track, ">")

                    if (i != -1):
                        track = stripText(track[i+1:])

                    i = string.find(track, " - ")
                    artist = ""

                    if (i != -1):
                        atist = stripText(track[i+3:])
                        track = stripText(track[0:i])

                aw.setTrack(diskCount, trackCount, track, artist=artist)
                tracks = tracks[i+1:]
                trackCount = trackCount + 1


    i = string.find(source, ">Escuchar muestras y comprar MP3<")

    if i != -1:
        disks = searchForPlus(source, ">Escuchar muestras y comprar MP3<")
        disks = searchForPlus(disks, "id='albumTrackList'")
        i = string.find(disks, "</DIV>")
        disks = stripText(disks[0:i])

        if string.find(disks, ">Disc ") == -1:
            disks = ">Disc 1<" + disks

        diskCount = 0

        while (searchFor(disks, ">Disc ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc ")
            i = string.find(disks, "<")
            disks = searchForPlus(disks, "class=\"columnHeader\"")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])

            trackIndex = 1

            while (searchFor(tracks, "class=\"titleCol\"") != None):
                trackid = "%02d" % trackIndex
                tracks = searchForPlus(tracks, "class=\"titleCol\"")
                tracks = searchForPlus(tracks, " href=\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                track = stripText(tracks[0:i])

                artist = ""
                i = string.find(tracks, "class=\"titleCol\"")

                if i != -1 and i < 100:
                    tracks = searchForPlus(tracks, "class=\"titleCol\"")
                    tracks = searchForPlus(tracks, " href=\"")
                    tracks = searchForPlus(tracks, ">")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])

                time = ""
                tracks = searchForPlus(tracks, "class=\"runtimeCol\"")
                tracks = searchForPlus(tracks, ">")
                i = string.find(tracks, "<")
                time = stripText(tracks[0:i])
                aw.setTrack(diskCount, trackIndex, track, artist=artist, time=time)

                trackIndex = trackIndex + 1


    # Find Comments
    tag = "id=\"productDescription\""
    i = string.find(source, tag)

    if i != -1:
        comments = searchForPlus(source, tag)
        comments = searchForPlus(comments, "<div")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "<div class=\"emptyClear\">")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<div class=\"seeAll\">")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "</form>")

        if i != -1:
            comments = comments[0:i]

        i = string.find(comments, "<hr noshade")

        if i != -1:
            comments = comments[0:i]

        # Fixed in 3.06
        comments =  string.replace(comments, "&#xab;", "")
        comments =  string.replace(comments, "&#xbb;", "")
        comments =  string.replace(comments, "&#xbf;", "")
        comments =  string.replace(comments, "&#xd3;", "")
        comments =  string.replace(comments, "&#xE1;", "")
        comments =  string.replace(comments, "&#xe1;", "")
        comments =  string.replace(comments, "&#xe9;", "")
        comments =  string.replace(comments, "&#xed;", "")
        comments =  string.replace(comments, "&#xf1;", "")
        comments =  string.replace(comments, "&#xF3;", "")
        comments =  string.replace(comments, "&#xf3;", "")
        comments =  string.replace(comments, "&#xfa;", "")
        aw.setProductInfo(comments)



try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
