# Barnes and Noble scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import convertArtist
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    aw.setCurrencySymbol("$")

    # Find Image
    i = string.find(source, "id=\"prodImage\"")

    if i != -1:
        images = searchForPlus(source, "id=\"prodImage\"")
        image = searchForPlus(images, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "0000000000")

        if i != -1:
            image = ""

        aw.setImage1("http:" + image)

    i = string.find(source, "<img id=\"viewer-image")

    if i != -1:
        images = searchForPlus(source, "<img id=\"viewer-image")
        images = searchFor(images, "http")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "0000000000")

        if i != -1:
            image = ""

        aw.setLargeImage1(image)


    # Find Category
    tag = "<h2>Related Subjects"
    i = string.find(source, tag)

    if i != -1:
        category = searchForPlus(source, tag)
        category = searchForPlus(category, "<a href")
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        category = stripText(category[0:i])

        aw.setCategory1(category)


    # Find Title
    source = searchForPlus(source, "id=\"prodSummary")
    source = searchForPlus(source, "<h")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    i = string.find(title, " [")

    if i != -1:
        title = stripText(title[0:i])

    aw.setTitle(title)

    if title == "The page you are looking for is currently unavailable.":
        aw.setTitle("")
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return


    # Find Artist
    i = string.find(source, "class=\"contributors\"")

    if i != -1:
        source = searchForPlus(source, "class=\"contributors\"")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        artist = stripText(source[0:i])
        artist = convertArtist(artist)
    else:
        artist = "Various Artists"

    aw.setArtist(artist)


    # Find List price
    i = string.find(source, "class=\"old-price\"")

    if i != -1:
        listprice = searchFor(source, "class=\"old-price\"")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, "<")
        aw.setListPrice(stripText(listprice[0:i]))


    # Find Retail Price (value)
    i = string.find(source, "itemprop=\"price\"")

    if i != -1:
        value = searchFor(source, "itemprop=\"price\"")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])

        i = string.find(value, "&")

        if i != -1:
            value = stripText(value[0:i])

        aw.setItemValue(value)

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Format
    i = string.find(source, "id=\"prodPromo\"")

    if i != -1:
        format = searchForPlus(source, "id=\"prodPromo\"")
        format = searchForPlus(format, "<h2")
        format = searchForPlus(format, ">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        i = string.find(format, " - ")

        if i != -1:
            format = stripText(format[0:i])

        aw.setFormat(format);


    # Find Running time
    i = string.find(source, ">Total Running Time:<")

    if i != -1:
        time = searchForPlus(source, ">Total Running Time:<")
        time = searchForPlus(time, ">")
        i = string.find(time, "<")
        time = stripText(time[0:i])
        aw.setRunningTime(time)


    # Find release date
    i = string.find(source, ">Release Date:")

    if i != -1:
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, "<td>")
        i = string.find(date, "<")
        aw.setReleaseDate(stripText(date[0:i]))


    # Find copyright date
    i = string.find(source, ">Original Release:")

    if i != -1:
        date = searchForPlus(source, ">Original Release:")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setCopyrightDate(date)


    # Find Label
    i = string.find(source, ">Label:")

    if i != -1:
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, "<td>")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Catalog Number
    i = string.find(source, ">catalogNumber:")

    if i != -1:
        num = searchForPlus(source, ">catalogNumber:")
        num = searchForPlus(num, "<td>")
        i = string.find(num, "<")
        num = stripText(num[0:i])
        aw.setCatalogNumber(num)


    # Find UPC
    i = string.find(source, ">UPC:")

    if i != -1:
        upc = searchForPlus(source, ">UPC:")
        upc = searchForPlus(upc, "<td>")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])

        while len(upc) < 12:
            upc = "0" + upc

        if len(upc) == 13 and upc[0:1] == "0":
            upc = upc[1:13] 

        aw.setUPC(upc)


    # Sales Rank
    i = string.find(source, ">Rank:")

    if i != -1:
        salesrank = searchForPlus(source, ">Rank:")
        salesrank = searchForPlus(salesrank, "<td>")
        i = string.find(salesrank, "<")
        aw.setSalesRank(salesrank[0:i])


    # Find Tracks
    i = string.find(source, "id=\"Tracks\"")
    diskCount = 0

    if i != -1:
        disks = searchForPlus(source, "id=\"Tracks\"")
        i = string.find(disks, "</article>")
        disks = stripText(disks[0:i])

        if string.find(disks, ">Disc") == -1:
            disks = ">Disc 1<" + disks

        altdisks = ""

        i = string.find(disks, "<td colspan=\"3\"><h3>")

        if i != -1:
            # Second track section, assume Classical
            aw.setType("Classical")

            altdisks = stripText(disks[i:])
            disks = stripText(disks[0:i])

            if string.find(altdisks, ">Disc") == -1:
                altdisks = ">Disc 1<" + altdisks

        while (searchFor(disks, ">Disc") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])
            trackNum = 0

            i = string.find(disks, "</ol>")
            tracks = stripText(disks[0:i])

            while (searchFor(tracks, "<li") != None):
                trackNum = trackNum + 1
                tracks = searchForPlus(tracks, "<li")
                tracks = stripText(searchForPlus(tracks, ">"))

                if tracks.startswith("<a") == 1:
                    tracks = searchForPlus(tracks, "\">")

                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                artist = ""
                i = string.find(tracks, "&nbsp;- ")

                if i != -1 and i <= 100:
                    tracks = searchForPlus(tracks, "&nbsp;- ")
                    i = string.find(tracks, "<")
                    artist = stripText(tracks[0:i])
                else:
                    i = string.find(tracks, "> / ")

                    if i != -1 and i <= 100:
                        artist = searchForPlus(tracks, "> / ")
                        i = string.find(artist, "<")
                        artist = stripText(artist[0:i])

                        i = string.find(artist, ":")

                        if i != -1:
                            i = string.rfind(artist, " ")
                            artist = stripText(artist[0:i])

                time = ""
                bonus = "false"
                #tracks = searchForPlus(tracks, "</b>")

                #if tracks.startswith("</a>") == 1:
                #    tracks = searchForPlus(tracks, "</a>")

                #i = string.find(tracks, "<")
                #time = stripText(tracks[0:i])
                #i = string.find(time, "Bonus Track")

                #if i != -1:
                #    bonus = "true"

                #i = string.rfind(time, " ")

                #if i != -1:
                #    time = stripText(time[i:])

                #i = string.find(time, ":")

                #if i == -1:
                #    time = ""

                aw.setTrack(diskCount, trackNum, title, artist=artist, time=time, bonus=bonus)

        diskCount = 0

        while (searchFor(altdisks, ">Disc") != None):
            diskCount = diskCount + 1
            altdisks = searchForPlus(altdisks, ">Disc")
            i = string.find(altdisks, "<")
            diskid = "%02d" % stripText(altdisks[0:i])
            trackNum = 0

            i = string.find(altdisks, "class=\"DiscNumber\"")

            if i != -1:
                tracks = stripText(altdisks[0:i])
            else:
                tracks = altdisks

            while (searchFor(tracks, "><b>") != None):
                trackNum = trackNum + 1
                tracks = searchForPlus(tracks, "><b>")

                i = string.find(tracks, "><b>")

                if i != -1:
                    track = stripText(tracks[0:i])
                else:
                    track = tracks

                i = string.find(track, "<")
                title = stripText(track[0:i])

                if title == "Track List":
                    continue

                time = ""
                i = string.find(track, "> ")

                if i != -1:
                    time = searchForPlus(track, "> ")
                    i = string.find(time, "<")
                    time = stripText(time[0:i])
                    i = string.rfind(time, " ")

                    if i != -1:
                        time = stripText(time[i:])

                    i = string.find(time, ":")

                    if i == -1:
                        time = ""

                composer = ""
                i = string.find(track, ">Composed by <")

                if i != -1:
                    composer = searchForPlus(track, ">Composed by <")
                    composer = searchForPlus(composer, "\">")
                    i = string.find(composer, "<")
                    composer = stripText(composer[0:i])

                conductor = ""
                i = string.find(track, ">Conducted by <")

                if i != -1:
                    conductor = searchForPlus(track, ">Conducted by <")
                    conductor = searchForPlus(conductor, "\">")
                    i = string.find(conductor, "<")
                    conductor = stripText(conductor[0:i])

                artist = ""
                i = string.find(track, ">Performed by <")

                if i != -1:
                    artist = searchForPlus(track, ">Performed by <")
                    artist = searchForPlus(artist, "\">")
                    i = string.find(artist, "<")
                    artist = stripText(artist[0:i])

                aw.setAltTrack(diskCount, trackNum, title, artist=artist, time=time, composer=composer, conductor=conductor)


    # Find Comments
    comments = ""

    i = string.rfind(source, ">Overview</h2>")

    if i != -1:
        comment = searchForPlus(source, ">Overview</h2>")
        comment = searchForPlus(comment, "\">")
        i = string.find(comment, "<div ")
        comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)


    i = string.rfind(source, "<h2>Editorial Reviews")

    if i != -1:
        comment = searchFor(source, "<h2>Editorial Reviews")
        i = string.find(comment, "</section>")
        comment = stripText(comment[0:i])

        i = string.find(comment, "<aside")

        if i != -1:
            comment = stripText(comment[0:i])

        i = string.find(comment, "<p class=\"read-more fade\">")

        if i != -1:
            comment = stripText(comment[0:i])

        comments = appendComment(comments, comment)

    comments = string.replace(comments, "<article>", "")
    comments = string.replace(comments, "</article>", "<br><br>")

    if comments != "":
        aw.setProductInfo(comments)


    # Find Rating
    i = string.find(source, "section_updateRating")

    if i != -1:
        rating = stripText(source[i-15:])
        rating = searchForPlus(rating, "=\"")
        i = string.find(rating, " ")
        rating = stripText(rating[0:i])
        rating = searchForPlus(rating, "avg-")

        if rating.endswith("h") == 1:
            rating = stripText(rating[0:len(rating)-1]) + ".5"

        aw.setMyRating(rating)




def extract2(source):
    aw.setCurrencySymbol("$")

    # Find Images
    i = string.find(source, "<div id=\"product-image-smaller-1\"")

    if i != -1:
        images = searchForPlus(source, "<div id=\"product-image-smaller-1\"")
        image = searchForPlus(images, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "/p/0000000000")

        if i != -1:
            image = None

        aw.setImage1(image)

        images = searchForPlus(images, "href=\"")
        i = string.find(images, "\"")
        images = stripText(images[0:i])

        i = string.find(images, "imageviewer.asp")

        if i != -1:
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            images = http.getContents(images)
            t2 = open(aw.getLogsDir() + "trace2.html", "w")
            t2.write(images)
            t2.close()

            i = string.rfind(images, "images:[")

            if i != -1:
                images = stripText(images[i:])
                i = string.find(images, "]")
                imagesline = stripText(images[0:i])

                i = string.find(imagesline, "'")

                if i != -1:
                    image = searchForPlus(imagesline, "'")
                    i = string.find(image, "'")
                    image = stripText(image[0:i])

                    i = string.find(image, "/p/0000000000")

                    if i != -1:
                        image = None

                    aw.setLargeImage1(image)

                i = string.find(imagesline, "','")

                if i != -1:
                    image = searchForPlus(imagesline, "','")
                    i = string.find(image, "\"")
                    image = stripText(image[0:i])

                    i = string.find(image, "/p/0000000000")

                    if i != -1:
                        image = None

                    aw.setLargeImage2(image)

            if aw.getLargeImage1() == None:
                i = string.find(images, "id=\"LARGE_IMAGE\"")

                if i != -1:
                    image = searchForPlus(images, "id=\"LARGE_IMAGE\"")
                    image = searchForPlus(image, "src=\"")
                    i = string.find(image, "\"")
                    image = stripText(image[0:i])

                    i = string.find(image, "/p/0000000000")

                    if i != -1:
                        image = None

                    aw.setLargeImage1(image)

                # Back image too?
                i = string.find(images, "alt=\"Back\"")

                if i != -1:
                    images = searchForPlus(images[i-200:], "<a href=\"")
                    i = string.find(images, "\"")
                    images = "http://video.barnesandnoble.com/search/" + stripText(images[0:i])
                    images = string.replace(images, "&amp;", "&")
                    http.blockForLoad();
                    images = http.getContents(images)
                    t2 = open(aw.getLogsDir() + "trace3.html", "w")
                    t2.write(images)
                    t2.close()

                    i = string.find(images, "id=\"BACK_IMAGE\"")

                    if i != -1:
                        image = searchForPlus(images, "id=\"BACK_IMAGE\"")
                        image = searchForPlus(image, "src=\"")
                        i = string.find(image, "\"")
                        image = stripText(image[0:i])

                        i = string.find(image, "/p/0000000000")

                        if i != -1:
                            image = None

                        aw.setLargeImage2(image)

    i = string.find(source, "<img id=\"viewer-image")

    if i != -1:
        images = searchForPlus(source, "<img id=\"viewer-image")
        images = searchFor(images, "http")
        i = string.find(images, "\"")
        image = stripText(images[0:i])

        i = string.find(image, "/p/0000000000")

        if i != -1:
            image = None

        aw.setLargeImage1(image)


    # Find Category
    tag = "id=\"product-commentary-related-categories-and-awards-1\""
    i = string.find(source, tag)

    if i != -1:
        category = searchForPlus(source, tag)
        category = searchForPlus(category, ">Related Categories<")
        category = searchForPlus(category, "<a href")
        category = searchForPlus(category, ">")
        i = string.find(category, "<")
        category = stripText(category[0:i])

        aw.setCategory1(category)


    # Find Title
    source = searchForPlus(source, "<div id=\"product-title-1\"")
    source = searchForPlus(source, "<h")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    i = string.find(title, " [")

    if i != -1:
        title = stripText(title[0:i])

    aw.setTitle(title)

    if title == "The page you are looking for is currently unavailable.":
        aw.setTitle("")
        source = searchFor(source, "force exception")
        source = searchFor(source, "force exception")
        return


    # Find Artist
    i = string.find(source, "class=\"byline\"")

    if i != -1:
        source = searchForPlus(source, "class=\"byline\"")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        artist = stripText(source[0:i])
        artist = convertArtist(artist)
    else:
        artist = "Various Artists"

    aw.setArtist(artist)


    # Find List price
    i = string.find(source, "class=\"list-price\"")

    if i != -1:
        listprice = searchFor(source, "class=\"list-price\"")
        listprice = searchFor(listprice, "$")
        i = string.find(listprice, " ")
        listprice = stripText(listprice[0:i])
        aw.setListPrice(listprice)


    # Find Retail Price (value)
    i = string.find(source, "class=\"price hilight\"")

    if i != -1:
        value = searchFor(source, "class=\"price hilight\"")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        aw.setItemValue(value)

        aw.setPurchasePrice(aw.getItemValue())
        aw.setPurchaseDate(Date())
        aw.setPurchasePlace(aw.getSource())


    # Find Format
    i = string.find(source, "class=\"bb-title\"")

    if i != -1:
        format = searchForPlus(source, "class=\"bb-title\"")
        format = searchForPlus(format, "<em>")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        i = string.find(format, " - ")

        if i != -1:
            format = stripText(format[0:i])

        aw.setFormat(format);


    # Find Running time
    i = string.find(source, ">Total Running Time:<")

    if i != -1:
        time = searchForPlus(source, ">Total Running Time:<")
        time = searchForPlus(time, ">")
        i = string.find(time, "<")
        time = stripText(time[0:i])
        aw.setRunningTime(time)


    # Find release date
    i = string.find(source, ">Release Date:")

    if i != -1:
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setReleaseDate(date)


    # Find copyright date
    i = string.find(source, ">Original Release:")

    if i != -1:
        date = searchForPlus(source, ">Original Release:")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        aw.setCopyrightDate(date)


    # Find Label
    i = string.find(source, ">Label:")

    if i != -1:
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, ">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Catalog Number
    i = string.find(source, ">Catalog Number:")

    if i != -1:
        num = searchForPlus(source, ">Catalog Number:")
        num = searchForPlus(num, ">")
        i = string.find(num, "<")
        num = stripText(num[0:i])
        aw.setCatalogNumber(num)


    # Find UPC
    i = string.find(source, ">UPC:")

    if i != -1:
        upc = searchForPlus(source, ">UPC:")
        upc = searchForPlus(upc, ">")
        i = string.find(upc, "<")
        upc = stripText(upc[0:i])

        while len(upc) < 12:
            upc = "0" + upc

        aw.setUPC(upc)


    # Sales Rank
    i = string.find(source, ">Sales rank:")

    if i != -1:
        salesrank = searchForPlus(source, ">Sales rank:")
        salesrank = searchForPlus(salesrank, ">")
        i = string.find(salesrank, "<")
        aw.setSalesRank(salesrank[0:i])


    # Find Tracks
    i = string.find(source, "id=\"product-commentary-tracks-1\"")
    diskCount = 0

    if i != -1:
        disks = searchForPlus(source, "id=\"product-commentary-tracks-1\"")
        disks = searchForPlus(disks, ">Tracks<")
        i = string.find(disks, "</section>")
        disks = stripText(disks[0:i])

        if string.find(disks, ">Disc") == -1:
            disks = ">Disc 1<" + disks

        while (searchFor(disks, ">Disc") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc")
            i = string.find(disks, "<")
            diskid = "%02d" % stripText(disks[0:i])
            trackNum = 0

            i = string.find(disks, ">Disc ")

            if i != -1:
                tracks = stripText(disks[0:i])
            else:
                tracks = disks

            while (searchFor(tracks, "class=\"track-name\"") != None):
                trackNum = trackNum + 1
                tracks = searchForPlus(tracks, "class=\"track-name\"")
                tracks = searchForPlus(tracks, ">")

                i = string.find(tracks, "<")
                title = stripText(tracks[0:i])

                i = string.find(tracks, "</li>")
                track = stripText(tracks[0:i])

                artist = ""
                time = ""
                bonus = "false"

                i = string.find(track, "class=\"runtime\"")

                if i != -1:
                    time = searchForPlus(track, "class=\"runtime\"")

                    i = string.find(track, "(")

                    if i != -1:
                        time = searchForPlus(time, "(")
                        i = string.find(time, ")")
                        time = stripText(time[0:i])
                    
                aw.setTrack(diskCount, trackNum, title, artist=artist, time=time, bonus=bonus)



    # Find Comments
    comments = ""
    i = string.find(source, "id=\"product-commentary-editorial-review-2\"")

    if i != -1:
        info = searchForPlus(source, "id=\"product-commentary-editorial-review-2\"")
        i = string.find(info, "</section>")
        info = stripText(info[0:i])

        while (searchFor(info, "class=\"simple-html\"") != None):
            info = searchForPlus(info, "class=\"simple-html\"")
            info = searchForPlus(info, ">")
            i = string.find(info, "</article>")
            comment = stripText(info[0:i])

            comment = string.replace(comment, "</h5>", "<br>")
            comment = string.replace(comment, "</h3><h2>", "")

            if comments == "":
                comments = comment;
            else:
                comments = comments + "<br><br>" + comment;
    else:
        i = string.find(source, "id=\"product-commentary-editorial-review-1\"")

        if i != -1:
            comment = searchForPlus(source, "id=\"product-commentary-editorial-review-1\"")
            comment = searchForPlus(comment, "<h3>")
            i = string.find(comment, "</article>")
            comment = stripText(comment[0:i])
            comment = string.replace(comment, "</h5>", "<br>")
            comment = string.replace(comment, "</h3><h2>", "")
            comment = string.replace(comment, "<article class=\"simple-html\">", "")

            if comments == "":
                comments = comment;
            else:
                comments = comments + "\n\n" + comment;

    if comments != "":
        aw.setProductInfo(comments)


    # Find Rating
    i = string.find(source, "id=\"reviews-average-rating-1\"")

    if i != -1:
        rating = searchForPlus(source, "id=\"reviews-average-rating-1\"")
        rating = searchForPlus(rating, "itemprop=\"ratingValue\"")
        rating = searchForPlus(rating, ">")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i])

        aw.setMyRating(rating)


try:
    aw.setAlbumObject(Album)
    extract(source)

    #i = string.find(source, "<div id=\"product-info\"")

    #if i != -1:
    #    extract(source)
    #else:
    #    extract2(source)

finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
