# Discogs music scraper
#
# Copyright  1999-2011 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  aw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Find Buyer Waiting
    i = string.find(source, ">Add to Wantlist<")

    if i != -1:
        buyerwaiting = searchForPlus(source, ">Add to Wantlist<")
        buyerwaiting = searchForPlus(buyerwaiting, "\">")
        i = string.find(buyerwaiting, " ")
        buyerwaiting = stripText(buyerwaiting[0:i])

        if buyerwaiting == "0":
            aw.setBuyerWaiting("false")
        else:
            aw.setBuyerWaiting("true")


    # Main Extraction

    # Find Discogs ID
    i = string.find(source, "\"id\":")

    if i != -1:
        amgid = searchForPlus(source, "\"id\":")
        amgid = searchForPlus(amgid, "\"")
        i = string.find(amgid, "\"")
        aw.setExternalID(stripText(amgid[0:i]))
    source = searchForPlus(source, "class=\"body\"")


    # Find Image
    imageTag = "class=\"image_gallery"
    i = string.find(source, imageTag)

    if i != -1:
        source = searchForPlus(source, imageTag)
        i = string.find(source, " src=\"")

        if i != -1:
            image = searchForPlus(source, " src=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])

            i = string.find(image, "music-no-image")

            if i == -1:
                aw.setRefImage1(image, "http://www.discogs.com/")

        i = string.find(source, "href=\"/viewimages")

        if i != -1:
            url = searchForPlus(source, "href=\"")
            i = string.find(url, "\"")
            url = stripText("http://www.discogs.com" + url[0:i])

            http = HTTPConnection()
            http.resetReferer();
            http.setGenericUserAgent()
            http.blockForLoad();
            images = http.getContents(url)
            t2 = open(aw.getLogsDir() + "trace2.html", "w")
            t2.write(images)
            t2.close()

            i = string.find(images, "id=\"page\"")

            if i != -1:
                image = searchForPlus(images, "id=\"page\"")
                image = searchForPlus(image, " src=\"")
                i = string.find(image, "\"")
                image = stripText(image[0:i])
                aw.setRefLargeImage1(image, "http://www.discogs.com/")


    # Find Artist
    i = string.find(source, "\"/artist/")

    if i != -1:
        source = searchForPlus(source, "\"/artist/")
        source = searchForPlus(source, ">")
        i = string.find(source, "<")
        artist = stripText(source[0:i])
        aw.setArtist(artist)


    # Find Title
    source = searchForPlus(source, "&ndash;")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    aw.setTitle(title)


    # Find Label
    i = string.find(source, ">Label:")

    if i != -1:
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, "class=\"content\"")
        label = searchForPlus(label, "\">")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setLabel(label)


    # Find Catalog Number
    i = string.find(source, ">Label:")

    if i != -1:
        label = searchForPlus(source, ">Label:")
        label = searchForPlus(label, "&lrm;&ndash;")
        i = string.find(label, "<")
        label = stripText(label[0:i])
        aw.setCatalogNumber(label)


    # Find Format
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "class=\"content\"")
        format = searchForPlus(format, "<a href=\"")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        format = stripText(format[0:i])
        aw.setFormat(format)


    # Find Date
    tag = ">Year:"
    i = string.find(source, tag)

    if i == -1:
        tag = ">Released:"
        i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, "class=\"content\"")
        date = searchForPlus(date, ">")
        date = stripText(date[0:i])

        if date.startswith("<a ") == 1:
            date = searchForPlus(date, ">")

        i = string.find(date, "<")
        date = stripText(date[0:i])

        aw.setReleaseDate(date)


    # Find Category
    i = string.find(source, ">Genre:<")

    if i != -1:
        categories = searchForPlus(source, ">Genre:<")
        categories = searchForPlus(categories, "class=\"content\"")
        categories = searchForPlus(categories, ">")
        i = string.find(categories, "</div>")
        categories = stripText(categories[0:i])

        ccount = 1

        while (searchFor(categories, "href=\"") != None):
            categories = searchForPlus(categories, "href=\"")
            categories = searchForPlus(categories, "\">")
            i = string.find(categories, "<")
            category = stripText(categories[0:i])

            if ccount == 1:
                aw.setCategory1(category)
            elif ccount == 2:
                aw.setCategory2(category)
            else:
                aw.setCategory3(category)
                break

            ccount = ccount + 1


    # Find Keywords
    keywordList = ""
    i = string.find(source, ">Style:<")

    if i != -1:
        keywords = searchForPlus(source, ">Style:<")
        keywords = searchForPlus(keywords, "class=\"content\"")
        keywords = searchForPlus(keywords, ">")
        i = string.find(keywords, "</div>")
        keywords = stripText(keywords[0:i])

        ccount = 1

        while (searchFor(keywords, "href=\"") != None):
            keywords = searchForPlus(keywords, "href=\"")
            keywords = searchForPlus(keywords, "\">")
            i = string.find(keywords, "<")
            keyword = stripText(keywords[0:i])

            if ccount == 1:
                keywordList = keyword
            else:
                keywordList = keywordList + ", " + keyword

            ccount = ccount + 1

        aw.setKeywords(keywordList)


    # Find Format keywords
    i = string.find(source, ">Format:<")

    if i != -1:
        format = searchForPlus(source, ">Format:<")
        format = searchForPlus(format, "class=\"content\"")
        format = searchForPlus(format, ">")
        i = string.find(format, "<br />")
        format = stripText(format[0:i])

        if keywordList == "":
            keywordList = format
        else:
            keywordList = keywordList + ", " + format

        aw.setKeywords(keywordList)


    # Find Comments
    comments = ""
    i = string.find(source, "data-for=\".notes\"")

    if i != -1:
        comments = searchForPlus(source, "data-for=\".notes\"")
        comments = searchForPlus(comments, "class=\"section_content toggle_section_content\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<!--")

        if i != -1:
            comments = stripText(comments[0:i])


    # Find Comments
    i = string.find(source, "data-for=\".credits\"")

    if i != -1:
        comment = searchForPlus(source, "data-for=\".credits\"")
        comment = searchForPlus(comment, "class=\"section_content toggle_section_content\"")
        comment = searchForPlus(comment, ">")
        i = string.find(comment, "</div>")
        comment = stripText(comment[0:i])
        comments = appendComment(comments, comment)

    aw.setProductInfo(comments)


    # Find Tracks
    i = string.find(source, "id=\"tracklist\"")

    if i != -1:
        source = searchForPlus(source, "id=\"tracklist\"")
        i = string.find(source, "</table>")
        disks = stripText(source[0:i])

        if string.find(disks, ">Disc: ") == -1:
            disks = ">Disc: 1<" + disks

        trackList = []
        artistList = []
        timeList = []
        diskCount = 0

        while (searchFor(disks, ">Disc: ") != None):
            diskCount = diskCount + 1
            disks = searchForPlus(disks, ">Disc: ")

            i = string.find(disks, "</table>")
            tracks = stripText(disks[0:i])
            trackCount = 0

            while (searchFor(tracks, "itemprop=\"track\"") != None):
                tracks = searchForPlus(tracks, "itemprop=\"track\"")
                i = string.find(tracks, "</tr>")
                track = stripText(tracks[0:i])

                artist = ""

                i = string.find(track, "class=\"tracklist_track_artists\">")
                
                if i != -1:
                    track = stripText(searchForPlus(track, "class=\"tracklist_track_artists\">"))
                    i = string.find(track, "</td>")
                    artists = stripText(track[0:i])

                    while (searchFor(artists, "href=") != None):
                        artists = searchForPlus(artists, "href=")
                        artists = searchForPlus(artists, "\">")
                        i = string.find(artists, "<")

                        if artist == "":
                            artist = stripText(artists[0:i])
                        else:
                            artist = artist + ", " + stripText(artists[0:i])

                track = searchForPlus(track, "class=\"tracklist_track_title\"")
                track = searchForPlus(track, ">")
                i = string.find(track, "<")
                title = stripText(track[0:i])
                trackCount = trackCount + 1

                writer = ""

                i = string.find(track, "Written-By")
                
                if i != -1:
                    track = searchForPlus(track, "Written-By")
                    i = string.find(track, "</span>")
                    writers = stripText(track[0:i])

                    while (searchFor(writers, "\">") != None):
                        writers = searchForPlus(writers, "\">")
                        i = string.find(writers, "<")

                        if writer == "":
                            writer = stripText(writers[0:i])
                        else:
                            writer = writer + " / " + stripText(writers[0:i])


                time = ""

                i = string.find(track, "class=\"tracklist_track_duration\"")
                
                if i != -1:
                    track = searchForPlus(track, "class=\"tracklist_track_duration\"")
                    track = searchForPlus(track, "<span>")
                    i = string.find(track, "<")
                    time = stripText(track[0:i])

                aw.setTrack(diskCount, trackCount, title, time=time, artist=artist, songwriter=writer)



try:
    aw.setAlbumObject(Album)
    extract(source)
finally:
    if os.path.exists(aw.getDocsDir() + "awuserexit.py"):
        execfile(aw.getDocsDir() + "awuserexit.py") in globals()
