# Books-A-Million scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setCurrencySymbol("$")

    i = string.find(source, ">Not Available")
        
    if i != -1:
        return


    i = string.find(source, ">&nbsp;Current Search")

    if i != -1:
        source = searchForPlus(source, ">&nbsp;Current Search")
        source = searchForPlus(source, "class=\"list\"")
        source = searchForPlus(source, "href=\"")
        i = string.find(source, "\"")
        url = stripText(source[0:i])
        http = HTTPConnection()
        http.blockForLoad();
        source = http.getContents(url)
        t2 = open(rw.getLogsDir() + "trace2.html", "w")
        t2.write(source)
        t2.close()



    # Find Image
    i = string.find(source, "id=\"details-image-container\"")

    if i != -1:
        images = searchForPlus(source, "id=\"details-image-container\"")
        i = string.find(images, "</div>")
        images = stripText(images[0:i])
        image = searchForPlus(images, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        rw.setImage1(image)

        i = string.find(images, "href=\"")

        if i != -1:
            image = searchForPlus(images, "href=\"")
            i = string.find(image, "\"")
            image = stripText(image[0:i])
            rw.setLargeImage1(image)


    # Find Book details
    source = searchForPlus(source, "id=\"details-description-container\"")


    # Find Title
    title = searchForPlus(source, "<strong>")
    i = string.find(title, "<")
    title = stripText(title[0:i])
    rw.setTitle(stripText(title[0:i]))


    # Find Format
    i = string.find(title, " (")

    if i != -1:
        rw.setTitle(stripText(title[0:i]))

        format = searchForPlus(title, " (")
        i = string.find(format, ")")
        rw.setFormat(stripText(format[0:i]))



    # Find Author
    authors = searchForPlus(source, ">by ")
    i = string.find(authors, "</span>")
    authors = stripText(authors[0:i])
    authorList = []

    while (searchFor(authors, "href=\"") != None):
        authors = searchForPlus(authors, "href=\"")
        authors = searchForPlus(authors, "\">")
        i = string.find(authors, "<")
        author = stripText(authors[0:i])
        authorList.append(author)

    rw.setAuthors(authorList)



    # Find Price
    i = string.find(source, "class=\"price-block-binding\"")

    if i != -1:
        value = searchForPlus(source, "class=\"price-block-binding\"")
        value = searchForPlus(value, "<strong>")
        i = string.find(value, "<")
        value = stripText(value[0:i])
        rw.setItemValue(value)

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find List price
    i = string.find(source, ">Retail Price:")

    if i != -1:
        listprice = searchForPlus(source, ">Retail Price:")
        listprice = searchForPlus(listprice, ">")
        i = string.find(listprice, "<")
        rw.setListPrice(stripText(listprice[0:i]))


    # Find Comments
    i = string.find(source, "name=\"overview\"")

    if i != -1:
        comments = searchForPlus(source, "name=\"overview\"")
        comments = searchForPlus(comments, "id=\"sec-hdr\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "<p></p></div>")
        comments = stripText(comments[0:i])
        comments = string.replace(comments, "</div><div>", "<br>")

        i = string.find(comments, "<object ")

        if i != -1:
            comments = stripText(comments[0:i])

        i = string.find(comments, "<hr/>")

        if i != -1:
            comments = stripText(comments[0:i])

        rw.setProductInfo(comments)


    # Find category
    i = string.find(source, ">Related Categories<")

    if i != -1:
        category = searchForPlus(source, ">Related Categories<")
        category = searchForPlus(category, "<p>")
        i = string.find(category, "</p>")
        category = stripText(category[0:i])
        i = string.rfind(category, "<a href=")
        category = stripText(category[i:])
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        rw.setCategory1(stripText(category[0:i]))


    # Find ISBN
    i = string.find(source, ">ISBN-13")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN-13")
        isbn = searchForPlus(isbn, ":")
        i = string.find(isbn, "<")
        isbn = stripText(isbn[0:i])

        if (isbn[len(isbn)-1:] == "/"):
            isbn = isbn[0:len(isbn)-2]
            
        rw.setISBN(isbn)


    # Find Publisher
    i = string.find(source, ">Publisher<")

    if i != -1:
        publisher = searchForPlus(source, ">Publisher<")
        publisher = searchForPlus(publisher, ":")
        i = string.find(publisher, "<")
        publisher = stripText(publisher[0:i])

        if (publisher[len(publisher)-1:] == "/"):
            publisher = publisher[0:len(publisher)-2]

        rw.setPublisher(publisher)


    # Find Publication Date
    i = string.find(source, ">Publish Date<")

    if i != -1:
        date = searchForPlus(source, ">Publish Date<")
        date = searchForPlus(date, ":")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        if (date[len(date)-1:] == "/"):
            date = date[0:len(date)-2]

        rw.setReleaseDate(date)


    # Find Pages
    i = string.find(source, ">Page Count<")

    if i != -1:
        pages = searchForPlus(source, ">Page Count<")
        pages = searchForPlus(pages, ":")
        i = string.find(pages, "<")
        rw.setPages(stripText(pages[0:i]))


    # Find Reading level
    i = string.find(source, ">Reading Level<")

    if i != -1:
        readinglevel = searchForPlus(source, ">Reading Level<")
        readinglevel = searchForPlus(readinglevel, ":")
        i = string.find(readinglevel, "<")
        rw.setReadingLevel(stripText(readinglevel[0:i]))


try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
