# Libris scraper


import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # 10 digit ISBN search failed?
    i = string.find(source, ">Your search found no results.")

    if i != -1:
        source = searchForPlus(source, ">Your search found no results.")
        source = searchForPlus(source, "ISBN/ISSN etc.")
        source = searchForPlus(source, "value=\"")
        i = string.find(source, "\"")
        isbn13 = stripText(source[0:i])

        if len(isbn13) == 10:
            isbn13 = "978" + isbn13[0:9]
            isbn13 = calcISBN13CheckDigit(isbn13)

            url = "http://websok.libris.kb.se/websearch/search?SEARCH_NUMM=" + isbn13 + "&lang=eng"
            http = HTTPConnection()
            http.resetReferer();
            http.blockForLoad();
            source = http.getContents(url)

            try:
                t2 = open(rw.getLogsDir() + "trace2.html", "w")
                t2.write(source)
                t2.close()
            except:
                print "Unable to create trace2.html"


    # Find Image
    i = string.find(source, "class=\"image\"")

    if i != -1:
        image = searchForPlus(source, "class=\"image\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])
        rw.setImage1(image)


    # Find title / author
    author = ""
    title = searchForPlus(source, "class=\"kortvyvanster")
    title = searchForPlus(title, "<h1>")
    i = string.find(title, "</h1>")
    title = stripText(title[0:i])

    i = string.find(title, " / ")

    if i != -1:
        author = stripText(title[i+2:])
        title = stripText(title[0:i])

    i = string.find(author, "&ouml;vers&auml;ttning:")

    if i != -1:
        translator = searchForPlus(author, "&ouml;vers&auml;ttning:")

        i = string.find(translator, " ; ")

        if i != -1:
            translator = stripText(translator[0:i])

        rw.setTranslator(translator)

    # med == with
    i = string.find(author, " med ")

    if i != -1:
        author = stripText(author[0:i])

    i = string.find(author, " ; ")

    if i != -1:
        author = stripText(author[0:i])

    rw.setTitle(title)
    rw.setAuthor(author)


    # Find isbn
    i = string.find(source, ">ISBN")

    if i != -1:
        source = searchForPlus(source, ">ISBN")
        i = string.find(source, "<")
        isbn = stripText(source[0:i])
        isbn = string.replace(isbn, "-", "")
        isbn = string.replace(isbn, "&nbsp;", "")

        i = string.find(isbn, " (")

        if i != -1:
            isbn = stripText(isbn[0:i])

        rw.setISBN(isbn)


    # Find publisher
    i = string.find(source, "&amp;rft.pub=")

    if i != -1:
        publisher = searchForPlus(source, "&amp;rft.pub=")
        i = string.find(publisher, "&amp;")
        publisher = stripText(publisher[0:i])
        publisher = stripText(string.replace(publisher, "+", " "))
        publisher = stripText(string.replace(publisher, "%C3%A5", ""))
        publisher = cleanUp(publisher)
        rw.setPublisher(publisher)


    # Find release date
    i = string.find(source, "&amp;rft.date=")

    if i != -1:
        date = searchForPlus(source, "&amp;rft.date=")
        i = string.find(date, "&amp;")
        date = stripText(date[0:i])
        date = stripText(string.replace(date, "+", " "))
        rw.setReleaseDate(date)


    # Find page count
    i = string.find(source, "&amp;rft.tpages=")

    if i != -1:
        pages = searchForPlus(source, "&amp;rft.tpages=")
        i = string.find(pages, "&amp;")
        pages = stripText(pages[0:i])
        pages = stripText(string.replace(pages, "+", " "))

        i = string.find(pages, " ")

        if i != -1:
            pages = stripText(pages[0:i])

        rw.setPages(pages)


    

def cleanUp(str):
    str = string.replace(str, "%C3%B6", "")
    str = string.replace(str, "%26", "&")
    return str




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
