# Powells scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  rw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    # Defaults
    rw.setPublicationPlace("US")
    rw.setLanguage("English")
    rw.setCurrencySymbol("$")

    # Summary or detail page
    i = string.find(source, ">Titles per page:<")

    if i != -1:
        # Summary page
        # Find Match, if any
        i = string.find(source, "<!-- RESULT ITEM START -->")

        if i == -1:
            return

        source = searchForPlus(source, "<!-- RESULT ITEM START -->")
        source = searchForPlus(source, "HREF=\"")
        i = string.find(source, "\"")
        url = "http://www.powells.com" + stripText(source[0:i])
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        source = http.getContents(url)


    # Detail display
    # Find Price
    i = string.find(source, "class=\"price\"")

    if i != -1:
        value = searchForPlus(source, "class=\"price\"")
        value = searchFor(value, "$")
        i = string.find(value, "<")
        rw.setItemValue(stripText(value[0:i]))

        rw.setPurchasePrice(rw.getItemValue())
        rw.setPurchaseDate(Date())
        rw.setPurchasePlace(rw.getSource())


    # Find Image, if any
    i = string.find(source, "<img id=\"cover\"")

    if i != -1:
        image = searchForPlus(source, "<img id=\"cover\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "nopicture")

        if i != -1:
            image = ""

        i = string.find(image, "noimage")

        if i != -1:
            image = ""

        i = string.find(image, "clearpixel")

        if i != -1:
            image = ""

        if image != "":
            rw.setImage1(image)

    # Find Title
    title = searchForPlus(source, " class='book-title'")
    title = searchForPlus(title, ">")
    i = string.find(title, "<")
    rw.setTitle(stripText(title[0:i]))

    # Find Author
    author = searchForPlus(source, " class='book-title'")
    author = searchForPlus(author, "author=")
    i = string.find(author, "\"")
    rw.setAuthor(stripText(author[0:i]))


    # Find ISBN
    i = string.find(source, ">ISBN13:<")

    if i != -1:
        isbn = searchForPlus(source, ">ISBN13:<")
        isbn = searchForPlus(isbn, ">")
        i = string.find(isbn, "<")
        rw.setISBN(stripText(isbn[0:i]))


    # Find Comments
    i = string.rfind(source, "id=\"synopses_and_reviews\"")

    if i != -1:
        comments = searchForPlus(source, "id=\"synopses_and_reviews\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "<br></div>")
        comments = stripText(comments[0:i])

        i = string.find(comments, "<div class='bt'>")

        if i != -1:
            comments = stripText(comments[0:i])

        rw.setProductInfo(comments)

    # Move on to product details if present.
    i = string.find(source, "<div id=\"product_details\">")

    if i != -1:
        source = searchForPlus(source, "<div id=\"product_details\">")

    # Find ISBN
    if rw.getISBN() == "":
        i = string.find(source, "class=\"isbn\"")

        if i != -1:
            isbn = searchForPlus(source, "class=\"isbn\"")
            isbn = searchForPlus(isbn, "\">")
            i = string.find(isbn, "<")
            rw.setISBN(stripText(isbn[0:i]))


    # Find Publisher
    i = string.find(source, "Publisher:")

    if i != -1:
        publisher = searchForPlus(source, "Publisher:")
        publisher = searchForPlus(publisher, "\">")
        i = string.find(publisher, "<")
        rw.setPublisher(stripText(publisher[0:i]))


    # Find Format
    i = string.find(source, "Binding:")

    if i != -1:
        format = searchForPlus(source, "Binding:")
        format = searchForPlus(format, "\">")
        i = string.find(format, "<")
        rw.setFormat(stripText(format[0:i]))


    # Find Date
    tag = "Publication Date:"

    i = string.find(source, tag)

    if i == -1:
        tag = "Year:"
        i = string.find(source, tag)

    if i != -1:
        date = searchForPlus(source, tag)
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        date = stripText(date[0:i])

        if date.startswith("c") == 1:
            date = stripText(date[1:])
            setCopyrightDate(date)

        rw.setReleaseDate(date)


    # Find Copyright Date
    i = string.find(source, "Copyright:")

    if i != -1:
        date = searchForPlus(source, "Copyright:")
        date = searchForPlus(date, "\">")
        i = string.find(date, "<")
        rw.setCopyrightDate(stripText(date[0:i]))


    # Find Pages
    i = string.find(source, "Pages:")

    if i != -1:
        pages = searchForPlus(source, "Pages:")
        pages = searchForPlus(pages, "\">")
        i = string.find(pages, "<")
        pages = stripText(pages[0:i])

        i = string.find(pages, " ")

        if (i != -1):
            pages = stripText(pages[0:i])

        rw.setPages(pages)


    # Find Dimensions
    i = string.find(source, "Dimensions:")

    if i != -1:
        dimensions = searchForPlus(source, "Dimensions:")
        dimensions = searchForPlus(dimensions, "\">")
        i = string.find(dimensions, "<")
        dimensions = stripText(dimensions[0:i])

        if dimensions.endswith(" lbs.") == 1:
            i = string.find(dimensions, "in.")

            if i != -1:
                rw.setWeight(stripText(dimensions[i+3:]))
            dimensions = stripText(dimensions[0:i+3])
        
        rw.setDimensions(dimensions)


    # Find Place
    i = string.find(source, "Published in:")

    if i != -1:
        place = searchForPlus(source, "Published in:")
        place = searchForPlus(place, "\">")
        i = string.find(place, "<")
        rw.setPublicationPlace(stripText(place[0:i]))


    # Find Language
    i = string.find(source, "Language:")

    if i != -1:
        language = searchForPlus(source, "Language:")
        language = searchForPlus(language, "\">")
        i = string.find(language, "<")
        rw.setLanguage(stripText(language[0:i]))


    # Find Category
    i = string.find(source, "Subject:")

    if i != -1:
        category = searchForPlus(source, "Subject:")
        category = searchForPlus(category, "\">")
        i = string.find(category, "<")
        rw.setCategory1(stripText(category[0:i]))

        i = string.find(category, "Subject:")

        if i != -1:
            category = searchForPlus(category, "Subject:")
            category = searchForPlus(category, "\">")
            i = string.find(category, "<")
            rw.setCategory2(stripText(category[0:i]))

            i = string.find(category, "Subject:")

            if i != -1:
                category = searchForPlus(category, "Subject:")
                category = searchForPlus(category, "\">")
                i = string.find(category, "<")
                rw.setCategory3(stripText(category[0:i]))




try:
    rw.setBookObject(Book)
    extract(source)
finally:
    if os.path.exists(rw.getDocsDir() + "rwuserexit.py"):
        execfile(rw.getDocsDir() + "rwuserexit.py") in globals()
