# imdb scraper
#
# Copyright  1999-2009 Readerware Corporation.  All Rights Reserved.

import  os
import  string

import  vw

from    com.readerware.http import HTTPConnection

from    rwsupport import searchFor
from    rwsupport import searchForPlus
from    rwsupport import stripText
from    rwsupport import appendComment

from    jarray import zeros, array
from    java.lang import String
from    java.util import Date


def extract(source):
    print "vwimdbdx.py.extract(source)" 

    # Defaults
    vw.setRegion("Region 1")
    vw.setAspectRatio("Standard")
    vw.setSubtitled("False")
    vw.setLanguage("English")
    vw.setCertification("NR")


    # Find Image referer
    referer = ""

    i = string.find(source, "rel=\"canonical\"")

    if i != -1:
        referer = searchForPlus(source, "rel=\"canonical\"")
        referer = searchForPlus(referer, "href=\"")
        i = string.find(referer, "\"")
        referer = stripText(referer[0:i])


    # Find Image
    i = string.find(source, "id=\"img_primary\"")

    if i != -1:
        image = searchForPlus(source, "id=\"img_primary\"")
        image = searchForPlus(image, "src=\"")
        i = string.find(image, "\"")
        image = stripText(image[0:i])

        i = string.find(image, "/nopicture/")

        if i == -1:
            vw.setRefImage1(image, referer)
    else:
        i = string.find(source, "class=\"poster\"")

        if i != -1:
            image = searchForPlus(source, "class=\"poster\"")
            image = searchForPlus(image, "src=\"")
            i = string.find(image, "\"")
            vw.setRefImage1(stripText(image[0:i]), referer)


    # Find user rating
    i = string.find(source, "itemprop=\"ratingValue\"")

    if i != -1:
        rating = searchForPlus(source, "itemprop=\"ratingValue\"")
        rating = searchForPlus(rating, ">")
        i = string.find(rating, "<")
        rating = stripText(rating[0:i]) + " (IMDB)"
        vw.setMyRating(rating)


    # Find Title
    source = searchForPlus(source, "class=\"title_wrapper\"")
    source = searchForPlus(source, "<h1")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    title = stripText(source[0:i])
    vw.setTitle(title)


    # Find US Rating
    i = string.find(source, "itemprop=\"contentRating\"")

    if i != -1:
        rating = searchForPlus(source, "itemprop=\"contentRating\"")
        rating = searchForPlus(rating, "content=\"")
        i = string.find(rating, "\"")
        rating = stripText(rating[0:i])
        rating = string.upper(rating) + " (MPAA)"
        vw.setCertification(rating)


    # Find keywords
    keywords = ""
    i = string.find(source, ">Plot Keywords:")

    if i != -1:
        page2 = searchForPlus(source, ">Plot Keywords:")
        i = string.find(page2, "</div")
        page2 = stripText(page2[0:i])

        while string.find(page2, "href=\"") != -1:
            page2 = searchForPlus(page2, "href=\"")

            if string.find(page2, "\">") == -1:
                break

            page2 = searchForPlus(page2, "\">")
            i = string.find(page2, "<")
            keyword = stripText(page2[0:i])

            if keywords == "":
                keywords =keyword   
            else:
                keywords = keywords + ", " + keyword

        vw.setKeywords(keywords)


    # Find credits
    comments = ""
    i = string.find(source, ">Full cast and crew<")

    if i != -1:
        url = referer + "fullcredits#cast"
        http = HTTPConnection()
        http.resetReferer();
        http.blockForLoad();
        page2 = http.getContents(url)
        t2 = open(vw.getLogsDir() + "trace2.html", "w")
        t2.write(page2)
        t2.close()

        i = string.find(page2, "/P#producer\"")

        if i != -1:
            producer = searchForPlus(page2, "/P#producer\"")
            producer = searchForPlus(producer, " href=")
            producer = searchForPlus(producer, "\">")
            i = string.find(producer, "<")
            producer = stripText(producer[0:i])
            vw.setProducer(producer)

        i = string.find(page2, "/E#editor\"")

        if i != -1:
            editor = searchForPlus(page2, "/E#editor\"")
            editor = searchForPlus(editor, " href=")
            editor = searchForPlus(editor, "\">")
            i = string.find(editor, "<")
            editor = stripText(editor[0:i])
            vw.setEditor(editor)

        i = string.find(page2, "/C#composer\"")

        if i != -1:
            composer = searchForPlus(page2, "/C#composer\"")
            composer = searchForPlus(composer, " href=")
            composer = searchForPlus(composer, "\">")
            i = string.find(composer, "<")
            composer = stripText(composer[0:i])
            vw.setComposer(composer)

        i = string.find(page2, "/C#cinematographer\"")

        if i != -1:
            photographer = searchForPlus(page2, "/C#cinematographer\"")
            photographer = searchForPlus(photographer, " href=")
            photographer = searchForPlus(photographer, "\">")
            i = string.find(photographer, "<")
            photographer = stripText(photographer[0:i])
            vw.setPhotographer(photographer)


    # Find Copyright date
    source = searchForPlus(source, "(")
    source = searchForPlus(source, ">")
    i = string.find(source, "<")
    vw.setCopyrightDate(stripText(source[0:i]))


    # Find Director
    i = string.find(source, "Director:")

    if i != -1:
        director = searchForPlus(source, "Director:")
        director = searchForPlus(director, "href")
        director = searchForPlus(director, ">")
        i = string.find(director, "<")
        director = stripText(director[0:i])
        vw.setDirector(director)


    # Find writers
    i = string.find(source, "Writers:")

    if i != -1:
        writers = searchForPlus(source, "Writers:")
        i = string.find(writers, "</div>")
        writers = stripText(writers[0:i])

        screenwriter = ""
        author = ""
        writer = ""

        while (searchFor(writers, "href") != None):
            writers = searchForPlus(writers, "href")

            i = string.find(writers, ">")

            if i == -1:
                break
            
            writers = searchForPlus(writers, ">")
            i = string.find(writers, "</span>")

            if i != -1:
                tempWriter = stripText(writers[0:i])
            else:
                i = string.find(writers, "</a>")
                tempWriter = stripText(writers[0:i+4])

            writerType = 0

            if string.find(tempWriter, "more credit") != -1:
                continue

            if string.find(tempWriter, "(novel)") != -1:
                writerType = 1

            if string.find(tempWriter, "(book)") != -1:
                writerType = 1

            if string.find(tempWriter, "(story") != -1:
                writerType = 2

            if string.find(tempWriter, "(short story") != -1:
                writerType = 2

            i = string.find(tempWriter, "<")

            if i != -1:
                tempWriter = stripText(tempWriter[0:i])

            i = string.find(tempWriter, "(")

            if i != -1:
                tempWriter = stripText(tempWriter[0:i])

            i = string.rfind(tempWriter, " ")

            if i != -1:
                tempWriter = stripText(tempWriter[i:]) + ", " + stripText(tempWriter[0:i])

            if tempWriter != "(more)" and tempWriter != "WGA" and tempWriter != "":
                if writerType == 0:
                    if screenwriter == "":
                        screenwriter = tempWriter
                        vw.setScreenwriter(screenwriter)
                elif writerType == 1:
                    if author == "":
                        author = tempWriter
                        vw.setAuthor(author)
                        vw.setBook(title)
                elif writerType == 2:
                    if writer == "":
                        writer = tempWriter
                        vw.setWriter(writer)


    # Find Release Date
    i = string.find(source, ">Release Date:")

    if i != -1:
        date = searchForPlus(source, ">Release Date:")
        date = searchForPlus(date, ">")
        i = string.find(date, "<")
        date = stripText(date[0:i])
        i = string.find(date, "(")

        if i != -1:
            date = stripText(date[0:i])

        vw.setReleaseDate(date)


    # Find Category
    i = string.find(source, ">Genre")

    if i != -1:
        categories = searchForPlus(source, ">Genre")
        i = string.find(categories, "</div>")
        categories = stripText(categories[0:i])
        count = 0

        while (searchFor(categories, "href") != None):
            categories = searchForPlus(categories, "href")
            categories = searchForPlus(categories, ">")
            i = string.find(categories, "<")

            next = stripText(categories[0:i])

            if next != "more":
                if count == 0:
                    vw.setCategory1(next)
                elif count == 1:
                    vw.setCategory2(next)
                elif count == 2:
                    vw.setCategory3(next)

            categories = categories[i:]
            count = count + 1


    # Find Comments
    i = string.find(source, "<h2>Storyline<")

    if i != -1:
        comments = searchForPlus(source, "<h2>Storyline<")
        comments = searchForPlus(comments, "<span>")
        i = string.find(comments, "<")
        comments = stripText(comments[0:i])
        vw.setProductInfo(comments)

    i = string.find(source, "class=\"plot_summary \"")

    if i != -1:
        comments = searchForPlus(source, "class=\"plot_summary \"")
        comments = searchForPlus(comments, "class=\"summary_text\"")
        comments = searchForPlus(comments, ">")
        i = string.find(comments, "</div>")
        vw.setProductInfo(stripText(comments[0:i]))

    i = string.find(source, ">Plot:<")

    if i != -1:
        source = searchForPlus(source, ">Plot:<")
        source = searchForPlus(source, "\">")
        i = string.find(source, "<")
        vw.setProductInfo(stripText(source[0:i]))


    # Find Actors
    castTag = "class=\"cast_list\""

    i = string.find(source, castTag)

    if i != -1:
        source = searchForPlus(source, castTag)
        i = string.find(source, "</table>")
        actors = stripText(source[0:i])

        while (searchFor(actors, "?ref_=tt_cl_t") != None):
            actors = searchForPlus(actors, "?ref_=tt_cl_t")
            actors = searchForPlus(actors, ">")
            i = string.find(actors, "<")
            actor = stripText(actors[0:i])
            vw.setActor(actor)


    # Find Running time
    i = string.find(source, ">Runtime")

    if i != -1:
        temp = searchForPlus(source, ">Runtime")
        i = string.find(temp, "</div>")

        if i != -1:
            temp = stripText(temp[0:i+1])

        i = string.find(temp, "USA:")

        if i != -1:
            temp = searchForPlus(temp, "USA:")
            temp = searchForPlus(temp, ">")
            i = string.find(temp, "<")
            running = stripText(temp[0:i])
        else:
            temp = searchForPlus(temp, "\">")
            i = string.find(temp, "<")
            running = stripText(temp[0:i])
            i = string.find(running, ":")

            if i != -1:
                running = stripText(running[i+1:])

        vw.setRunningTime(running)


    # Find Place
    i = string.find(source, ">Country")

    if i != -1:
        place = searchForPlus(source, ">Country")
        place = searchForPlus(place, "href")
        place = searchForPlus(place, ">")
        i = string.find(place, "<")
        vw.setPlace(stripText(place[0:i]))


    # Find Language
    i = string.find(source, ">Language:")

    if i != -1:
        language = searchForPlus(source, ">Language:")
        language = searchForPlus(language, "href")
        language = searchForPlus(language, ">")
        i = string.find(language, "<")
        vw.setLanguage(stripText(language[0:i]))


    # Find Color
    i = string.find(source, ">Color")

    if i != -1:
        color = searchForPlus(source, ">Color")
        color = searchForPlus(color, "href")
        color = searchForPlus(color, ">")
        i = string.find(color, "<")
        vw.setColor(stripText(color[0:i]))


    # Find Aspect Ratio
    i = string.find(source, ">Aspect Ratio:")

    if i != -1:
        aspect = searchForPlus(source, ">Aspect Ratio:")
        aspect = searchForPlus(aspect, ">")
        i = string.find(aspect, "<")
        vw.setAspectRatio(stripText(aspect[0:i]))


    # Find Sound
    i = string.find(source, ">Sound Mix:")

    if i != -1:
        sound = searchForPlus(source, ">Sound Mix:")
        sound = searchForPlus(sound, "href")
        sound = searchForPlus(sound, ">")
        i = string.find(sound, "<")
        sound = stripText(sound[0:i])
        vw.setSound(sound)


    # Find Rating
    i = string.find(source, ">Certificate:")

    if i != -1:
        cert = searchForPlus(source, ">Certificate:")
        cert = searchForPlus(cert, "<span>")
        i = string.find(cert, "<")
        vw.setCertification(stripText(cert[0:i]))


    # Find Studio
    i = string.find(source, ">Company Credits<")

    if i != -1:
        studio = searchForPlus(source, ">Company Credits<")
        studio = searchForPlus(studio, "href")
        studio = searchForPlus(studio, ">")
        i = string.find(studio, "<")
        vw.setStudio(stripText(studio[0:i]))


